package userdbclient;

import javax.swing.*;
import java.awt.*;
import java.awt.event.*;
import javax.swing.event.*;

import org.omg.CORBA.ORB;

import userdb.*;
import javax.swing.table.*;

import org.omg.CosTransactions.*;


/**
 * <p>Title: Client for Unix-User-Database-Administration</p>
 * <p>Description: </p>
 * <p>Copyright: Copyright (c) 2002</p>
 * <p>Company: HPI Potsdam</p>
 * @author Michael Dirska
 * @version 1.0
 */

public class Main extends JFrame {
  JMenuBar jMenuBar1 = new JMenuBar();
  JMenu jMenu1 = new JMenu();
  JMenuItem jMenuItem1 = new JMenuItem();
  GridLayout gridLayout1 = new GridLayout();
  JSplitPane jSplitPane1 = new JSplitPane();
  JPanel jPanel1 = new JPanel();
  JScrollPane jScrollPane1 = new JScrollPane();
  MyTableModel myTableModel1 = new MyTableModel();
  DefaultListSelectionModel defSelModel1 = new DefaultListSelectionModel();
  JLabel jLabel1 = new JLabel();
  GridBagLayout gridBagLayout1 = new GridBagLayout();
  JLabel jLabel2 = new JLabel();
  JLabel jLabel3 = new JLabel();
  JTextField jTextField1 = new JTextField();
  JTextField jTextField2 = new JTextField();
  JTextField jTextField3 = new JTextField();
  JTable jTable1 = new JTable();
  JButton jButton1 = new JButton();
  JMenuItem jMenuItem2 = new JMenuItem();


  ORB orb;
  JTextField jTextField4 = new JTextField();
  JTextField jTextField5 = new JTextField();
  JLabel jLabel4 = new JLabel();
  JLabel jLabel5 = new JLabel();
  Fehlermeldung fehlermeldung1;

  public Main(String args[]) {
    try {
      jbInit();
    }
    catch(Exception e) {
      e.printStackTrace();
    }

    orb = ORB.init (args, null);
    refresh();

    fehlermeldung1 = new Fehlermeldung(this);
  }


  public static void main(String[] args) {
    Main main1 = new Main(args);

    main1.setBounds(50,50,700,400);
    main1.pack();
    main1.show();


  }


  private void jbInit() throws Exception {

   this.getContentPane().setLayout(gridLayout1);
    this.addWindowListener(new java.awt.event.WindowAdapter() {
      public void windowClosing(WindowEvent e) {
        this_windowClosing(e);
      }
    });
    jMenu1.setText("File");
    jMenuItem1.setText("Exit");
    jMenuItem1.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        jMenuItem1_actionPerformed(e);
      }
    });
    jMenuItem2.setText("Refresh");
    jMenuItem2.addActionListener(new java.awt.event.ActionListener()
    {
      public void actionPerformed(ActionEvent e)
      {
        jMenuItem2_actionPerformed(e);
      }
    });

    jButton1.addActionListener(new java.awt.event.ActionListener()
    {
      public void actionPerformed(ActionEvent e)
      {
        jButton1_actionPerformed(e);
      }
    });
    jTextField4.setEditable(false);
    jTextField5.setEditable(false);
    jLabel4.setText("gid");
    jLabel5.setText("Heimatverzeichnis");
    jMenu1.add(jMenuItem2);
    jMenu1.addSeparator();
    jMenu1.add(jMenuItem1);

    jMenuBar1.add(jMenu1);
    this.setJMenuBar(jMenuBar1);
    this.setTitle("UserDBClient");


    defSelModel1.addListSelectionListener(new javax.swing.event.ListSelectionListener()
    {
      public void valueChanged(ListSelectionEvent e)
      {
        defSelModel1_valueChanged(e);
      }
    });

    jLabel1.setText("Name");
    jPanel1.setLayout(gridBagLayout1);
    jLabel2.setText("Loginname");
    jLabel3.setText("uid");
    jTextField1.setEditable(false);
    jTextField1.setText("              ");
    jTextField2.setEditable(false);
    jTextField3.setEditable(false);
    jTable1.setModel(myTableModel1);
    jTable1.setSelectionModel(defSelModel1);
    defSelModel1.setSelectionMode(0);
    defSelModel1.setLeadAnchorNotificationEnabled(false);
    jButton1.setEnabled(false);
    jButton1.setText("Login aktivieren");

    this.getContentPane().add(jSplitPane1, null);
    jSplitPane1.add(jPanel1, JSplitPane.RIGHT);
    jPanel1.add(jTextField1,                                new GridBagConstraints(1, 0, 2, 1, 0.0, 0.0
            ,GridBagConstraints.SOUTHWEST, GridBagConstraints.NONE, new Insets(0, -1, 2, 32), 57, 0));
    jPanel1.add(jLabel1,                        new GridBagConstraints(0, 0, 1, 1, 0.0, 0.0
            ,GridBagConstraints.EAST, GridBagConstraints.NONE, new Insets(9, 5, 4, 12), 0, 0));
    jPanel1.add(jButton1,                             new GridBagConstraints(0, 6, 2, 1, 0.0, 0.0
            ,GridBagConstraints.SOUTHEAST, GridBagConstraints.NONE, new Insets(0, 16, 0, 0), 0, 0));
    jPanel1.add(jTextField4,                      new GridBagConstraints(1, 2, 2, 2, 0.0, 0.0
            ,GridBagConstraints.SOUTHWEST, GridBagConstraints.NONE, new Insets(5, 0, 0, 0), 130, 0));
    jPanel1.add(jTextField5,                  new GridBagConstraints(1, 5, 2, 1, 0.0, 0.0
            ,GridBagConstraints.WEST, GridBagConstraints.NONE, new Insets(3, -1, 17, 1), 88, 0));
    jPanel1.add(jLabel2,          new GridBagConstraints(0, 1, 1, 2, 0.0, 0.0
            ,GridBagConstraints.EAST, GridBagConstraints.NONE, new Insets(2, 18, 0, 9), 6, 0));
    jPanel1.add(jTextField2,         new GridBagConstraints(1, 1, 2, 1, 0.0, 0.0
            ,GridBagConstraints.WEST, GridBagConstraints.NONE, new Insets(0, 0, 0, 0), 99, 0));
    jPanel1.add(jTextField3,           new GridBagConstraints(1, 4, 2, 1, 0.0, 0.0
            ,GridBagConstraints.SOUTHWEST, GridBagConstraints.NONE, new Insets(0, -1, 0, 0), 87, 0));
    jPanel1.add(jLabel4,                  new GridBagConstraints(0, 5, 1, 1, 0.0, 0.0
            ,GridBagConstraints.NORTHEAST, GridBagConstraints.NONE, new Insets(0, 8, 0, 7), 0, 0));
    jPanel1.add(jLabel3,     new GridBagConstraints(0, 4, 1, 1, 0.0, 0.0
            ,GridBagConstraints.EAST, GridBagConstraints.NONE, new Insets(0, 12, 4, 8), 0, 3));
    jPanel1.add(jLabel5,     new GridBagConstraints(0, 3, 1, 1, 0.0, 0.0
            ,GridBagConstraints.CENTER, GridBagConstraints.NONE, new Insets(0, 0, 0, 10), 0, 0));
    jSplitPane1.add(jScrollPane1, JSplitPane.LEFT);
    jScrollPane1.getViewport().add(jTable1, null);
  }


  void this_windowClosing(WindowEvent e) {
    System.exit(0);
  }

  void jMenuItem1_actionPerformed(ActionEvent e) {
    System.exit(0);
  }

  void defSelModel1_valueChanged(ListSelectionEvent e) {
    if (e.getValueIsAdjusting() == false)
    {
      int idx = defSelModel1.getLeadSelectionIndex();

      UnixUser u = myTableModel1.getUnixUserAt(idx);

      jTextField1.setText(u.name());
      jTextField2.setText(u.login());
      jTextField3.setText(new Integer(u.uid()).toString());
      jTextField5.setText(new Integer(u.gid()).toString());
      jTextField4.setText(u.homedir());

      jButton1.setEnabled( myTableModel1.isUnixUserNewAt(idx) );


    }
  }

  void jMenuItem2_actionPerformed(ActionEvent e)
  {
    refresh();
  }

  void refresh()
  {
    UnixUserHome uh = UnixUserHomeHelper.narrow(
              orb.string_to_object(
                 "corbaname::corbaname.md8.net:2809#UnixUserHome"));

    myTableModel1.loadList( uh.get_user_list() );
    myTableModel1.fireTableDataChanged();
  }

  void jButton1_actionPerformed(ActionEvent e)
  {
      int idx = defSelModel1.getLeadSelectionIndex();
      UnixUser user = myTableModel1.getUnixUserAt(idx);

      HomeDirCreator hdc = HomeDirCreatorHelper.narrow(
        orb.string_to_object(
           "corbaname::corbaname.md8.net:2809#HomeDirCreator"));

      try
      {
        org.omg.CosTransactions.Current txn_current = CurrentHelper.narrow(
           orb.resolve_initial_references("TransactionCurrent"));

        txn_current.begin();

        user.status(UnixUserStatus.READY);

        hdc.makeHomeDir (user.homedir(), user.uid(), user.gid());

        txn_current.commit(true);

        fehlermeldung1.showMsg("COMMITTED");
      }
      catch (org.omg.CORBA.TRANSACTION_ROLLEDBACK ex)
      {
        fehlermeldung1.showMsg("TRANSACTION ROLLEDBACK");
      }
      catch (Exception ex)
      {
        fehlermeldung1.showMsg("EXCEPTION");
        ex.printStackTrace();
      }

      refresh();
  }

}
