package userdb;

//
// Interface definition : UnixUser
//
// @author OpenORB Compiler
//
public class _UnixUserStub extends org.omg.CORBA.portable.ObjectImpl
		implements UnixUser
{
	static final String[] _ids_list =
	{
		"IDL:userdb/UnixUser:1.0"
	};

	public String[] _ids()
	{
		return _ids_list;
	}

	private final static Class _opsClass = userdb.UnixUserOperations.class;

	//
	// Read accessor for sid attribute
	// @return	the attribute value
	//
	public String sid()
	{
		while( true )
		{
			if (!this._is_local() )
			{
				org.omg.CORBA.portable.InputStream _input = null;
				try
				{
					org.omg.CORBA.portable.OutputStream _output = this._request("_get_sid",true);
					_input = this._invoke(_output);
					return _input.read_string();
				}
				catch( org.omg.CORBA.portable.RemarshalException _exception )
				{
					continue;
				}
				catch( org.omg.CORBA.portable.ApplicationException _exception )
				{
					String _exception_id = _exception.getId();
					throw new org.omg.CORBA.UNKNOWN("Unexcepected User Exception: "+ _exception_id);
				}
				finally
				{
					this._releaseReply(_input);
				}
			}
			else
			{
				org.omg.CORBA.portable.ServantObject _so = _servant_preinvoke("_get_sid",_opsClass);
				if ( _so == null )
				   continue;
				userdb.UnixUserOperations _self = ( userdb.UnixUserOperations ) _so.servant;
				try
				{
					return _self.sid();
				}
				finally
				{
					_servant_postinvoke(_so);
				}
			}
		}
	}

	//
	// Read accessor for login attribute
	// @return	the attribute value
	//
	public String login()
	{
		while( true )
		{
			if (!this._is_local() )
			{
				org.omg.CORBA.portable.InputStream _input = null;
				try
				{
					org.omg.CORBA.portable.OutputStream _output = this._request("_get_login",true);
					_input = this._invoke(_output);
					return _input.read_string();
				}
				catch( org.omg.CORBA.portable.RemarshalException _exception )
				{
					continue;
				}
				catch( org.omg.CORBA.portable.ApplicationException _exception )
				{
					String _exception_id = _exception.getId();
					throw new org.omg.CORBA.UNKNOWN("Unexcepected User Exception: "+ _exception_id);
				}
				finally
				{
					this._releaseReply(_input);
				}
			}
			else
			{
				org.omg.CORBA.portable.ServantObject _so = _servant_preinvoke("_get_login",_opsClass);
				if ( _so == null )
				   continue;
				userdb.UnixUserOperations _self = ( userdb.UnixUserOperations ) _so.servant;
				try
				{
					return _self.login();
				}
				finally
				{
					_servant_postinvoke(_so);
				}
			}
		}
	}

	//
	// Read accessor for uid attribute
	// @return	the attribute value
	//
	public int uid()
	{
		while( true )
		{
			if (!this._is_local() )
			{
				org.omg.CORBA.portable.InputStream _input = null;
				try
				{
					org.omg.CORBA.portable.OutputStream _output = this._request("_get_uid",true);
					_input = this._invoke(_output);
					return _input.read_long();
				}
				catch( org.omg.CORBA.portable.RemarshalException _exception )
				{
					continue;
				}
				catch( org.omg.CORBA.portable.ApplicationException _exception )
				{
					String _exception_id = _exception.getId();
					throw new org.omg.CORBA.UNKNOWN("Unexcepected User Exception: "+ _exception_id);
				}
				finally
				{
					this._releaseReply(_input);
				}
			}
			else
			{
				org.omg.CORBA.portable.ServantObject _so = _servant_preinvoke("_get_uid",_opsClass);
				if ( _so == null )
				   continue;
				userdb.UnixUserOperations _self = ( userdb.UnixUserOperations ) _so.servant;
				try
				{
					return _self.uid();
				}
				finally
				{
					_servant_postinvoke(_so);
				}
			}
		}
	}

	//
	// Read accessor for gid attribute
	// @return	the attribute value
	//
	public int gid()
	{
		while( true )
		{
			if (!this._is_local() )
			{
				org.omg.CORBA.portable.InputStream _input = null;
				try
				{
					org.omg.CORBA.portable.OutputStream _output = this._request("_get_gid",true);
					_input = this._invoke(_output);
					return _input.read_long();
				}
				catch( org.omg.CORBA.portable.RemarshalException _exception )
				{
					continue;
				}
				catch( org.omg.CORBA.portable.ApplicationException _exception )
				{
					String _exception_id = _exception.getId();
					throw new org.omg.CORBA.UNKNOWN("Unexcepected User Exception: "+ _exception_id);
				}
				finally
				{
					this._releaseReply(_input);
				}
			}
			else
			{
				org.omg.CORBA.portable.ServantObject _so = _servant_preinvoke("_get_gid",_opsClass);
				if ( _so == null )
				   continue;
				userdb.UnixUserOperations _self = ( userdb.UnixUserOperations ) _so.servant;
				try
				{
					return _self.gid();
				}
				finally
				{
					_servant_postinvoke(_so);
				}
			}
		}
	}

	//
	// Read accessor for name attribute
	// @return	the attribute value
	//
	public String name()
	{
		while( true )
		{
			if (!this._is_local() )
			{
				org.omg.CORBA.portable.InputStream _input = null;
				try
				{
					org.omg.CORBA.portable.OutputStream _output = this._request("_get_name",true);
					_input = this._invoke(_output);
					return _input.read_string();
				}
				catch( org.omg.CORBA.portable.RemarshalException _exception )
				{
					continue;
				}
				catch( org.omg.CORBA.portable.ApplicationException _exception )
				{
					String _exception_id = _exception.getId();
					throw new org.omg.CORBA.UNKNOWN("Unexcepected User Exception: "+ _exception_id);
				}
				finally
				{
					this._releaseReply(_input);
				}
			}
			else
			{
				org.omg.CORBA.portable.ServantObject _so = _servant_preinvoke("_get_name",_opsClass);
				if ( _so == null )
				   continue;
				userdb.UnixUserOperations _self = ( userdb.UnixUserOperations ) _so.servant;
				try
				{
					return _self.name();
				}
				finally
				{
					_servant_postinvoke(_so);
				}
			}
		}
	}

	//
	// Read accessor for homedir attribute
	// @return	the attribute value
	//
	public String homedir()
	{
		while( true )
		{
			if (!this._is_local() )
			{
				org.omg.CORBA.portable.InputStream _input = null;
				try
				{
					org.omg.CORBA.portable.OutputStream _output = this._request("_get_homedir",true);
					_input = this._invoke(_output);
					return _input.read_string();
				}
				catch( org.omg.CORBA.portable.RemarshalException _exception )
				{
					continue;
				}
				catch( org.omg.CORBA.portable.ApplicationException _exception )
				{
					String _exception_id = _exception.getId();
					throw new org.omg.CORBA.UNKNOWN("Unexcepected User Exception: "+ _exception_id);
				}
				finally
				{
					this._releaseReply(_input);
				}
			}
			else
			{
				org.omg.CORBA.portable.ServantObject _so = _servant_preinvoke("_get_homedir",_opsClass);
				if ( _so == null )
				   continue;
				userdb.UnixUserOperations _self = ( userdb.UnixUserOperations ) _so.servant;
				try
				{
					return _self.homedir();
				}
				finally
				{
					_servant_postinvoke(_so);
				}
			}
		}
	}

	//
	// Read accessor for status attribute
	// @return	the attribute value
	//
	public userdb.UnixUserStatus status()
	{
		while( true )
		{
			if (!this._is_local() )
			{
				org.omg.CORBA.portable.InputStream _input = null;
				try
				{
					org.omg.CORBA.portable.OutputStream _output = this._request("_get_status",true);
					_input = this._invoke(_output);
					return userdb.UnixUserStatusHelper.read(_input);
				}
				catch( org.omg.CORBA.portable.RemarshalException _exception )
				{
					continue;
				}
				catch( org.omg.CORBA.portable.ApplicationException _exception )
				{
					String _exception_id = _exception.getId();
					throw new org.omg.CORBA.UNKNOWN("Unexcepected User Exception: "+ _exception_id);
				}
				finally
				{
					this._releaseReply(_input);
				}
			}
			else
			{
				org.omg.CORBA.portable.ServantObject _so = _servant_preinvoke("_get_status",_opsClass);
				if ( _so == null )
				   continue;
				userdb.UnixUserOperations _self = ( userdb.UnixUserOperations ) _so.servant;
				try
				{
					return _self.status();
				}
				finally
				{
					_servant_postinvoke(_so);
				}
			}
		}
	}

	//
	// Write accessor for status attribute
	// @param	value	the attribute value
	//
	public void status( userdb.UnixUserStatus value )
	{
		while( true )
		{
			if (!this._is_local() )
			{
					org.omg.CORBA.portable.InputStream _input = null;
				try
				{
					org.omg.CORBA.portable.OutputStream _output = this._request("_set_status",true);
					userdb.UnixUserStatusHelper.write(_output,value);
					_input = this._invoke(_output);
					return;
				}
				catch( org.omg.CORBA.portable.RemarshalException _exception )
				{
					continue;
				}
				catch( org.omg.CORBA.portable.ApplicationException _exception )
				{
					String _exception_id = _exception.getId();
					throw new org.omg.CORBA.UNKNOWN("Unexcepected User Exception: "+ _exception_id);
				}
				finally
				{
					this._releaseReply(_input);
				}
			}
			else
			{
				org.omg.CORBA.portable.ServantObject _so = _servant_preinvoke("_set_status",_opsClass);
				if ( _so == null )
				   continue;
				userdb.UnixUser _self = ( userdb.UnixUser ) _so.servant;
				try
				{
					_self.status(value);
					return;
				}
				finally
				{
					_servant_postinvoke(_so);
				}
			}
		}
	}

}
