package userdb;

//
// Helper class for : UnixUserHome
//
// @author OpenORB Compiler
//
public class UnixUserHomeHelper
{
	//
	// Insert UnixUserHome into an any
	// @param	a an any
	// @param	t UnixUserHome value
	//
	public static void insert( org.omg.CORBA.Any a, userdb.UnixUserHome t )
	{
		a.insert_Object( t , type() );
	}

	//
	// Extract UnixUserHome from an any
	// @param	a an any
	// @return the extracted UnixUserHome value
	//
	public static userdb.UnixUserHome extract( org.omg.CORBA.Any a )
	{
		if ( !a.type().equal( type() ) )
			throw new org.omg.CORBA.MARSHAL();
		try {
			return userdb.UnixUserHomeHelper.narrow( a.extract_Object() );
		}
		catch ( org.omg.CORBA.BAD_PARAM ex ) {
			throw new org.omg.CORBA.MARSHAL();
		}
	}

	//
	// Internal TypeCode value
	//
	private static org.omg.CORBA.TypeCode _tc = null;

	//
	// Return the UnixUserHome TypeCode
	// @return a TypeCode
	//
	public static org.omg.CORBA.TypeCode type()
	{
		if ( _tc == null ) {
			org.omg.CORBA.ORB orb = org.omg.CORBA.ORB.init();
			_tc = orb.create_interface_tc(id(),"UnixUserHome");
		}
		return _tc;
	}

	//
	// Return the UnixUserHome IDL ID
	// @return an ID
	//
	public static String id()
	{
		return _id;
	}

	private final static String _id = "IDL:userdb/UnixUserHome:1.0";

	//
	// Read UnixUserHome from a marshalled stream
	// @param	istream the input stream
	// @return the readed UnixUserHome value
	//
	public static userdb.UnixUserHome read( org.omg.CORBA.portable.InputStream istream )
	{
		return( userdb.UnixUserHome )istream.read_Object( userdb._UnixUserHomeStub.class );
	}

	//
	// Write UnixUserHome into a marshalled stream
	// @param	ostream the output stream
	// @param	value UnixUserHome value
	//
	public static void write( org.omg.CORBA.portable.OutputStream ostream, userdb.UnixUserHome value )
	{
		ostream.write_Object((org.omg.CORBA.portable.ObjectImpl)value);
	}

	//
	// Narrow CORBA::Object to UnixUserHome
	// @param	obj the CORBA Object
	// @return UnixUserHome Object
	//
	public static UnixUserHome narrow( org.omg.CORBA.Object obj )
	{
		if ( obj == null )
			return null;
		if ( obj instanceof UnixUserHome )
			return ( UnixUserHome)obj;

		if ( obj._is_a( id() ) )
		{
			_UnixUserHomeStub stub = new _UnixUserHomeStub();
			stub._set_delegate( ((org.omg.CORBA.portable.ObjectImpl)obj)._get_delegate() );
			return stub;
		}

		throw new org.omg.CORBA.BAD_PARAM();
	}

	//
	// Unchecked Narrow CORBA::Object to UnixUserHome
	// @param	obj the CORBA Object
	// @return UnixUserHome Object
	//
	public static UnixUserHome unchecked_narrow( org.omg.CORBA.Object obj )
	{
		if ( obj == null )
			return null;
		if ( obj instanceof UnixUserHome )
			return ( UnixUserHome)obj;

		_UnixUserHomeStub stub = new _UnixUserHomeStub();
		stub._set_delegate( ((org.omg.CORBA.portable.ObjectImpl)obj)._get_delegate() );
		return stub;

	}

}
