package userdb;

//
// Interface definition : UnixUserHome
//
// @author OpenORB Compiler
//
public abstract class UnixUserHomePOA extends org.omg.PortableServer.Servant
		implements UnixUserHomeOperations, org.omg.CORBA.portable.InvokeHandler
{
	public UnixUserHome _this()
	{
		return UnixUserHomeHelper.narrow(_this_object());
	}

	public UnixUserHome _this( org.omg.CORBA.ORB orb )
	{
		return UnixUserHomeHelper.narrow(_this_object(orb));
	}

	private static String [] _ids_list =
	{
		"IDL:userdb/UnixUserHome:1.0"
	};

	public String[] _all_interfaces( org.omg.PortableServer.POA poa, byte [] objectId)
	{
		return _ids_list;
	}

	public org.omg.CORBA.portable.OutputStream _invoke ( String opName,
	                                                     org.omg.CORBA.portable.InputStream _is,
	                                                     org.omg.CORBA.portable.ResponseHandler handler)
	{
		org.omg.CORBA.portable.OutputStream _output = null;

		if ( opName.equals("find_by_login") )
		{
			String arg0_in = _is.read_string();

			try
			{
				userdb.UnixUser _arg_result = find_by_login(arg0_in);

				_output = handler.createReply();
				userdb.UnixUserHelper.write(_output,_arg_result);

			}
			catch ( userdb.UnixUserNotFound _exception )
			{
				_output = handler.createExceptionReply();
				userdb.UnixUserNotFoundHelper.write(_output,_exception);
			}
			return _output;
		}
		else
			throw new org.omg.CORBA.BAD_OPERATION();
	}
}
