package userdb;

//
// Interface definition : UnixUser
//
// @author OpenORB Compiler
//
public abstract class UnixUserPOA extends org.omg.PortableServer.Servant
		implements UnixUserOperations, org.omg.CORBA.portable.InvokeHandler
{
	public UnixUser _this()
	{
		return UnixUserHelper.narrow(_this_object());
	}

	public UnixUser _this( org.omg.CORBA.ORB orb )
	{
		return UnixUserHelper.narrow(_this_object(orb));
	}

	private static String [] _ids_list =
	{
		"IDL:userdb/UnixUser:1.0"
	};

	public String[] _all_interfaces( org.omg.PortableServer.POA poa, byte [] objectId)
	{
		return _ids_list;
	}

	public org.omg.CORBA.portable.OutputStream _invoke ( String opName,
	                                                     org.omg.CORBA.portable.InputStream _is,
	                                                     org.omg.CORBA.portable.ResponseHandler handler)
	{
		org.omg.CORBA.portable.OutputStream _output = null;

		if ( opName.equals("_get_sid") )
		{
			String arg = sid();
			_output = handler.createReply();
			_output.write_string(arg);
			return _output;
		}
		else
		if ( opName.equals("_get_login") )
		{
			String arg = login();
			_output = handler.createReply();
			_output.write_string(arg);
			return _output;
		}
		else
		if ( opName.equals("_get_uid") )
		{
			int arg = uid();
			_output = handler.createReply();
			_output.write_long(arg);
			return _output;
		}
		else
		if ( opName.equals("_get_gid") )
		{
			int arg = gid();
			_output = handler.createReply();
			_output.write_long(arg);
			return _output;
		}
		else
		if ( opName.equals("_get_name") )
		{
			String arg = name();
			_output = handler.createReply();
			_output.write_string(arg);
			return _output;
		}
		else
		if ( opName.equals("_get_homedir") )
		{
			String arg = homedir();
			_output = handler.createReply();
			_output.write_string(arg);
			return _output;
		}
		else
		if ( opName.equals("_get_status") )
		{
			userdb.UnixUserStatus arg = status();
			_output = handler.createReply();
			userdb.UnixUserStatusHelper.write(_output,arg);
			return _output;
		}
		else
		if ( opName.equals("_set_status") )
		{
			userdb.UnixUserStatus result = userdb.UnixUserStatusHelper.read(_is);

			status( result );
			_output = handler.createReply();
			return _output;
		}
		else
			throw new org.omg.CORBA.BAD_OPERATION();
	}
}
