package userdb;

//
// Interface definition : HomeDirCreator
//
// @author OpenORB Compiler
//
public class _HomeDirCreatorStub extends org.omg.CORBA.portable.ObjectImpl
		implements HomeDirCreator
{
	static final String[] _ids_list =
	{
		"IDL:userdb/HomeDirCreator:1.0", 
		"IDL:omg.org/CosTransactions/TransactionalObject:1.0"
	};

	public String[] _ids()
	{
		return _ids_list;
	}

	private final static Class _opsClass = userdb.HomeDirCreatorOperations.class;

	//
	// Operation makeHomeDir
	//
	public void makeHomeDir(String path, int uid, int gid)
	{
		while( true )
		{
			if (!this._is_local() )
			{
				org.omg.CORBA.portable.InputStream _input = null;
				try
				{
					org.omg.CORBA.portable.OutputStream _output = this._request("makeHomeDir",true);
					_output.write_string(path);
					_output.write_long(uid);
					_output.write_long(gid);
					_input = this._invoke(_output);
					return;
				}
				catch( org.omg.CORBA.portable.RemarshalException _exception )
				{
					continue;
				}
				catch( org.omg.CORBA.portable.ApplicationException _exception )
				{
					String _exception_id = _exception.getId();
					throw new org.omg.CORBA.UNKNOWN("Unexcepected User Exception: "+ _exception_id);
				}
				finally
				{
					this._releaseReply(_input);
				}
			}
			else
			{
				org.omg.CORBA.portable.ServantObject _so = _servant_preinvoke("makeHomeDir",_opsClass);
				if ( _so == null )
				   continue;
				userdb.HomeDirCreatorOperations _self = ( userdb.HomeDirCreatorOperations ) _so.servant;
				try
				{
					_self.makeHomeDir( path,  uid,  gid);
					return;
				}
				finally
				{
					_servant_postinvoke(_so);
				}
			}
		}
	}

}
