package userdb;

//
// Interface definition : HomeDirCreator
//
// @author OpenORB Compiler
//
public class HomeDirCreatorPOATie extends HomeDirCreatorPOA
{

	//
	// Private reference to implementation object
	//
	private HomeDirCreatorOperations _tie;

	//
	// Private reference to POA
	//
	private org.omg.PortableServer.POA _poa;

	//
	// Constructor
	//
	public HomeDirCreatorPOATie( HomeDirCreatorOperations tieObject )
	{
		_tie = tieObject;
	}

	//
	// Constructor
	//
	public HomeDirCreatorPOATie( HomeDirCreatorOperations tieObject, org.omg.PortableServer.POA poa )
	{
		_tie = tieObject;
		_poa = poa;
	}

	//
	// Get the delegate
	//
	public HomeDirCreatorOperations _delegate()
	{
		return _tie;
	}

	//
	// Set the delegate
	//
	public void _delegate( HomeDirCreatorOperations delegate_)
	{
		_tie = delegate_;
	}

	//
	//
	//
	public org.omg.PortableServer.POA _default_POA()
	{
		if ( _poa != null )
		    return _poa;
		else
		    return super._default_POA();
	}

	//
	// Operation makeHomeDir
	//
	public void makeHomeDir(String path, int uid, int gid)
	{
		_tie.makeHomeDir( path,  uid,  gid);
	}

}
