package userdb;

//
// Helper class for : UnixUser
//
// @author OpenORB Compiler
//
public class UnixUserHelper
{
	//
	// Insert UnixUser into an any
	// @param	a an any
	// @param	t UnixUser value
	//
	public static void insert( org.omg.CORBA.Any a, userdb.UnixUser t )
	{
		a.insert_Object( t , type() );
	}

	//
	// Extract UnixUser from an any
	// @param	a an any
	// @return the extracted UnixUser value
	//
	public static userdb.UnixUser extract( org.omg.CORBA.Any a )
	{
		if ( !a.type().equal( type() ) )
			throw new org.omg.CORBA.MARSHAL();
		try {
			return userdb.UnixUserHelper.narrow( a.extract_Object() );
		}
		catch ( org.omg.CORBA.BAD_PARAM ex ) {
			throw new org.omg.CORBA.MARSHAL();
		}
	}

	//
	// Internal TypeCode value
	//
	private static org.omg.CORBA.TypeCode _tc = null;

	//
	// Return the UnixUser TypeCode
	// @return a TypeCode
	//
	public static org.omg.CORBA.TypeCode type()
	{
		if ( _tc == null ) {
			org.omg.CORBA.ORB orb = org.omg.CORBA.ORB.init();
			_tc = orb.create_interface_tc(id(),"UnixUser");
		}
		return _tc;
	}

	//
	// Return the UnixUser IDL ID
	// @return an ID
	//
	public static String id()
	{
		return _id;
	}

	private final static String _id = "IDL:userdb/UnixUser:1.0";

	//
	// Read UnixUser from a marshalled stream
	// @param	istream the input stream
	// @return the readed UnixUser value
	//
	public static userdb.UnixUser read( org.omg.CORBA.portable.InputStream istream )
	{
		return( userdb.UnixUser )istream.read_Object( userdb._UnixUserStub.class );
	}

	//
	// Write UnixUser into a marshalled stream
	// @param	ostream the output stream
	// @param	value UnixUser value
	//
	public static void write( org.omg.CORBA.portable.OutputStream ostream, userdb.UnixUser value )
	{
		ostream.write_Object((org.omg.CORBA.portable.ObjectImpl)value);
	}

	//
	// Narrow CORBA::Object to UnixUser
	// @param	obj the CORBA Object
	// @return UnixUser Object
	//
	public static UnixUser narrow( org.omg.CORBA.Object obj )
	{
		if ( obj == null )
			return null;
		if ( obj instanceof UnixUser )
			return ( UnixUser)obj;

		if ( obj._is_a( id() ) )
		{
			_UnixUserStub stub = new _UnixUserStub();
			stub._set_delegate( ((org.omg.CORBA.portable.ObjectImpl)obj)._get_delegate() );
			return stub;
		}

		throw new org.omg.CORBA.BAD_PARAM();
	}

	//
	// Unchecked Narrow CORBA::Object to UnixUser
	// @param	obj the CORBA Object
	// @return UnixUser Object
	//
	public static UnixUser unchecked_narrow( org.omg.CORBA.Object obj )
	{
		if ( obj == null )
			return null;
		if ( obj instanceof UnixUser )
			return ( UnixUser)obj;

		_UnixUserStub stub = new _UnixUserStub();
		stub._set_delegate( ((org.omg.CORBA.portable.ObjectImpl)obj)._get_delegate() );
		return stub;

	}

}
